]> git.ipfire.org Git - thirdparty/git.git/blob - git-fetch.sh
GIT-VERSION-FILE: check ./version first.
[thirdparty/git.git] / git-fetch.sh
1 #!/bin/sh
2 #
3
4 USAGE='<fetch-options> <repository> <refspec>...'
5 SUBDIRECTORY_OK=Yes
6 . git-sh-setup
7 set_reflog_action "fetch $*"
8 cd_to_toplevel ;# probably unnecessary...
9
10 . git-parse-remote
11 _x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
12 _x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
13
14 LF='
15 '
16 IFS="$LF"
17
18 no_tags=
19 tags=
20 append=
21 force=
22 verbose=
23 update_head_ok=
24 exec=
25 keep=
26 shallow_depth=
27 while case "$#" in 0) break ;; esac
28 do
29 case "$1" in
30 -a|--a|--ap|--app|--appe|--appen|--append)
31 append=t
32 ;;
33 --upl|--uplo|--uploa|--upload|--upload-|--upload-p|\
34 --upload-pa|--upload-pac|--upload-pack)
35 shift
36 exec="--upload-pack=$1"
37 ;;
38 --upl=*|--uplo=*|--uploa=*|--upload=*|\
39 --upload-=*|--upload-p=*|--upload-pa=*|--upload-pac=*|--upload-pack=*)
40 exec=--upload-pack=$(expr "z$1" : 'z-[^=]*=\(.*\)')
41 shift
42 ;;
43 -f|--f|--fo|--for|--forc|--force)
44 force=t
45 ;;
46 -t|--t|--ta|--tag|--tags)
47 tags=t
48 ;;
49 -n|--n|--no|--no-|--no-t|--no-ta|--no-tag|--no-tags)
50 no_tags=t
51 ;;
52 -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
53 --update-he|--update-hea|--update-head|--update-head-|\
54 --update-head-o|--update-head-ok)
55 update_head_ok=t
56 ;;
57 -v|--verbose)
58 verbose=Yes
59 ;;
60 -k|--k|--ke|--kee|--keep)
61 keep='-k -k'
62 ;;
63 --depth=*)
64 shallow_depth="--depth=`expr "z$1" : 'z-[^=]*=\(.*\)'`"
65 ;;
66 --depth)
67 shift
68 shallow_depth="--depth=$1"
69 ;;
70 -*)
71 usage
72 ;;
73 *)
74 break
75 ;;
76 esac
77 shift
78 done
79
80 case "$#" in
81 0)
82 origin=$(get_default_remote)
83 test -n "$(get_remote_url ${origin})" ||
84 die "Where do you want to fetch from today?"
85 set x $origin ; shift ;;
86 esac
87
88 if test -z "$exec"
89 then
90 # No command line override and we have configuration for the remote.
91 exec="--upload-pack=$(get_uploadpack $1)"
92 fi
93
94 remote_nick="$1"
95 remote=$(get_remote_url "$@")
96 refs=
97 rref=
98 rsync_slurped_objects=
99
100 if test "" = "$append"
101 then
102 : >"$GIT_DIR/FETCH_HEAD"
103 fi
104
105 # Global that is reused later
106 ls_remote_result=$(git ls-remote $exec "$remote") ||
107 die "Cannot get the repository state from $remote"
108
109 append_fetch_head () {
110 head_="$1"
111 remote_="$2"
112 remote_name_="$3"
113 remote_nick_="$4"
114 local_name_="$5"
115 case "$6" in
116 t) not_for_merge_='not-for-merge' ;;
117 '') not_for_merge_= ;;
118 esac
119
120 # remote-nick is the URL given on the command line (or a shorthand)
121 # remote-name is the $GIT_DIR relative refs/ path we computed
122 # for this refspec.
123
124 # the $note_ variable will be fed to git-fmt-merge-msg for further
125 # processing.
126 case "$remote_name_" in
127 HEAD)
128 note_= ;;
129 refs/heads/*)
130 note_="$(expr "$remote_name_" : 'refs/heads/\(.*\)')"
131 note_="branch '$note_' of " ;;
132 refs/tags/*)
133 note_="$(expr "$remote_name_" : 'refs/tags/\(.*\)')"
134 note_="tag '$note_' of " ;;
135 refs/remotes/*)
136 note_="$(expr "$remote_name_" : 'refs/remotes/\(.*\)')"
137 note_="remote branch '$note_' of " ;;
138 *)
139 note_="$remote_name of " ;;
140 esac
141 remote_1_=$(expr "z$remote_" : 'z\(.*\)\.git/*$') &&
142 remote_="$remote_1_"
143 note_="$note_$remote_"
144
145 # 2.6.11-tree tag would not be happy to be fed to resolve.
146 if git-cat-file commit "$head_" >/dev/null 2>&1
147 then
148 headc_=$(git-rev-parse --verify "$head_^0") || exit
149 echo "$headc_ $not_for_merge_ $note_" >>"$GIT_DIR/FETCH_HEAD"
150 else
151 echo "$head_ not-for-merge $note_" >>"$GIT_DIR/FETCH_HEAD"
152 fi
153
154 update_local_ref "$local_name_" "$head_" "$note_"
155 }
156
157 update_local_ref () {
158 # If we are storing the head locally make sure that it is
159 # a fast forward (aka "reverse push").
160
161 label_=$(git-cat-file -t $2)
162 newshort_=$(git-rev-parse --short $2)
163 if test -z "$1" ; then
164 [ "$verbose" ] && echo >&2 "* fetched $3"
165 [ "$verbose" ] && echo >&2 " $label_: $newshort_"
166 return 0
167 fi
168 oldshort_=$(git show-ref --hash --abbrev "$1" 2>/dev/null)
169
170 case "$1" in
171 refs/tags/*)
172 # Tags need not be pointing at commits so there
173 # is no way to guarantee "fast-forward" anyway.
174 if test -n "$oldshort_"
175 then
176 if now_=$(git show-ref --hash "$1") && test "$now_" = "$2"
177 then
178 [ "$verbose" ] && echo >&2 "* $1: same as $3"
179 [ "$verbose" ] && echo >&2 " $label_: $newshort_" ||:
180 else
181 echo >&2 "* $1: updating with $3"
182 echo >&2 " $label_: $newshort_"
183 git-update-ref -m "$GIT_REFLOG_ACTION: updating tag" "$1" "$2"
184 fi
185 else
186 echo >&2 "* $1: storing $3"
187 echo >&2 " $label_: $newshort_"
188 git-update-ref -m "$GIT_REFLOG_ACTION: storing tag" "$1" "$2"
189 fi
190 ;;
191
192 refs/heads/* | refs/remotes/*)
193 # $1 is the ref being updated.
194 # $2 is the new value for the ref.
195 local=$(git-rev-parse --verify "$1^0" 2>/dev/null)
196 if test "$local"
197 then
198 # Require fast-forward.
199 mb=$(git-merge-base "$local" "$2") &&
200 case "$2,$mb" in
201 $local,*)
202 if test -n "$verbose"
203 then
204 echo >&2 "* $1: same as $3"
205 echo >&2 " $label_: $newshort_"
206 fi
207 ;;
208 *,$local)
209 echo >&2 "* $1: fast forward to $3"
210 echo >&2 " old..new: $oldshort_..$newshort_"
211 git-update-ref -m "$GIT_REFLOG_ACTION: fast-forward" "$1" "$2" "$local"
212 ;;
213 *)
214 false
215 ;;
216 esac || {
217 case ",$force,$single_force," in
218 *,t,*)
219 echo >&2 "* $1: forcing update to non-fast forward $3"
220 echo >&2 " old...new: $oldshort_...$newshort_"
221 git-update-ref -m "$GIT_REFLOG_ACTION: forced-update" "$1" "$2" "$local"
222 ;;
223 *)
224 echo >&2 "* $1: not updating to non-fast forward $3"
225 echo >&2 " old...new: $oldshort_...$newshort_"
226 exit 1
227 ;;
228 esac
229 }
230 else
231 echo >&2 "* $1: storing $3"
232 echo >&2 " $label_: $newshort_"
233 git-update-ref -m "$GIT_REFLOG_ACTION: storing head" "$1" "$2"
234 fi
235 ;;
236 esac
237 }
238
239 # updating the current HEAD with git-fetch in a bare
240 # repository is always fine.
241 if test -z "$update_head_ok" && test $(is_bare_repository) = false
242 then
243 orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
244 fi
245
246 # If --tags (and later --heads or --all) is specified, then we are
247 # not talking about defaults stored in Pull: line of remotes or
248 # branches file, and just fetch those and refspecs explicitly given.
249 # Otherwise we do what we always did.
250
251 reflist=$(get_remote_refs_for_fetch "$@")
252 if test "$tags"
253 then
254 taglist=`IFS=' ' &&
255 echo "$ls_remote_result" |
256 git-show-ref --exclude-existing=refs/tags/ |
257 while read sha1 name
258 do
259 echo ".${name}:${name}"
260 done` || exit
261 if test "$#" -gt 1
262 then
263 # remote URL plus explicit refspecs; we need to merge them.
264 reflist="$reflist$LF$taglist"
265 else
266 # No explicit refspecs; fetch tags only.
267 reflist=$taglist
268 fi
269 fi
270
271 fetch_main () {
272 reflist="$1"
273 refs=
274 rref=
275
276 for ref in $reflist
277 do
278 refs="$refs$LF$ref"
279
280 # These are relative path from $GIT_DIR, typically starting at refs/
281 # but may be HEAD
282 if expr "z$ref" : 'z\.' >/dev/null
283 then
284 not_for_merge=t
285 ref=$(expr "z$ref" : 'z\.\(.*\)')
286 else
287 not_for_merge=
288 fi
289 if expr "z$ref" : 'z+' >/dev/null
290 then
291 single_force=t
292 ref=$(expr "z$ref" : 'z+\(.*\)')
293 else
294 single_force=
295 fi
296 remote_name=$(expr "z$ref" : 'z\([^:]*\):')
297 local_name=$(expr "z$ref" : 'z[^:]*:\(.*\)')
298
299 rref="$rref$LF$remote_name"
300
301 # There are transports that can fetch only one head at a time...
302 case "$remote" in
303 http://* | https://* | ftp://*)
304 test -n "$shallow_depth" &&
305 die "shallow clone with http not supported"
306 proto=`expr "$remote" : '\([^:]*\):'`
307 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
308 curl_extra_args="-k"
309 fi
310 if [ -n "$GIT_CURL_FTP_NO_EPSV" -o \
311 "`git-config --bool http.noEPSV`" = true ]; then
312 noepsv_opt="--disable-epsv"
313 fi
314
315 # Find $remote_name from ls-remote output.
316 head=$(
317 IFS=' '
318 echo "$ls_remote_result" |
319 while read sha1 name
320 do
321 test "z$name" = "z$remote_name" || continue
322 echo "$sha1"
323 break
324 done
325 )
326 expr "z$head" : "z$_x40\$" >/dev/null ||
327 die "No such ref $remote_name at $remote"
328 echo >&2 "Fetching $remote_name from $remote using $proto"
329 git-http-fetch -v -a "$head" "$remote/" || exit
330 ;;
331 rsync://*)
332 test -n "$shallow_depth" &&
333 die "shallow clone with rsync not supported"
334 TMP_HEAD="$GIT_DIR/TMP_HEAD"
335 rsync -L -q "$remote/$remote_name" "$TMP_HEAD" || exit 1
336 head=$(git-rev-parse --verify TMP_HEAD)
337 rm -f "$TMP_HEAD"
338 test "$rsync_slurped_objects" || {
339 rsync -av --ignore-existing --exclude info \
340 "$remote/objects/" "$GIT_OBJECT_DIRECTORY/" || exit
341
342 # Look at objects/info/alternates for rsync -- http will
343 # support it natively and git native ones will do it on
344 # the remote end. Not having that file is not a crime.
345 rsync -q "$remote/objects/info/alternates" \
346 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
347 rm -f "$GIT_DIR/TMP_ALT"
348 if test -f "$GIT_DIR/TMP_ALT"
349 then
350 resolve_alternates "$remote" <"$GIT_DIR/TMP_ALT" |
351 while read alt
352 do
353 case "$alt" in 'bad alternate: '*) die "$alt";; esac
354 echo >&2 "Getting alternate: $alt"
355 rsync -av --ignore-existing --exclude info \
356 "$alt" "$GIT_OBJECT_DIRECTORY/" || exit
357 done
358 rm -f "$GIT_DIR/TMP_ALT"
359 fi
360 rsync_slurped_objects=t
361 }
362 ;;
363 *)
364 # We will do git native transport with just one call later.
365 continue ;;
366 esac
367
368 append_fetch_head "$head" "$remote" \
369 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge" || exit
370
371 done
372
373 case "$remote" in
374 http://* | https://* | ftp://* | rsync://* )
375 ;; # we are already done.
376 *)
377 ( : subshell because we muck with IFS
378 IFS=" $LF"
379 (
380 git-fetch-pack --thin $exec $keep $shallow_depth "$remote" $rref ||
381 echo failed "$remote"
382 ) |
383 (
384 trap '
385 if test -n "$keepfile" && test -f "$keepfile"
386 then
387 rm -f "$keepfile"
388 fi
389 ' 0
390
391 keepfile=
392 while read sha1 remote_name
393 do
394 case "$sha1" in
395 failed)
396 echo >&2 "Fetch failure: $remote"
397 exit 1 ;;
398 # special line coming from index-pack with the pack name
399 pack)
400 continue ;;
401 keep)
402 keepfile="$GIT_OBJECT_DIRECTORY/pack/pack-$remote_name.keep"
403 continue ;;
404 esac
405 found=
406 single_force=
407 for ref in $refs
408 do
409 case "$ref" in
410 +$remote_name:*)
411 single_force=t
412 not_for_merge=
413 found="$ref"
414 break ;;
415 .+$remote_name:*)
416 single_force=t
417 not_for_merge=t
418 found="$ref"
419 break ;;
420 .$remote_name:*)
421 not_for_merge=t
422 found="$ref"
423 break ;;
424 $remote_name:*)
425 not_for_merge=
426 found="$ref"
427 break ;;
428 esac
429 done
430 local_name=$(expr "z$found" : 'z[^:]*:\(.*\)')
431 append_fetch_head "$sha1" "$remote" \
432 "$remote_name" "$remote_nick" "$local_name" \
433 "$not_for_merge" || exit
434 done
435 )
436 ) || exit ;;
437 esac
438
439 }
440
441 fetch_main "$reflist" || exit
442
443 # automated tag following
444 case "$no_tags$tags" in
445 '')
446 case "$reflist" in
447 *:refs/*)
448 # effective only when we are following remote branch
449 # using local tracking branch.
450 taglist=$(IFS=' ' &&
451 echo "$ls_remote_result" |
452 git-show-ref --exclude-existing=refs/tags/ |
453 while read sha1 name
454 do
455 git-cat-file -t "$sha1" >/dev/null 2>&1 || continue
456 echo >&2 "Auto-following $name"
457 echo ".${name}:${name}"
458 done)
459 esac
460 case "$taglist" in
461 '') ;;
462 ?*)
463 # do not deepen a shallow tree when following tags
464 shallow_depth=
465 fetch_main "$taglist" || exit ;;
466 esac
467 esac
468
469 # If the original head was empty (i.e. no "master" yet), or
470 # if we were told not to worry, we do not have to check.
471 case "$orig_head" in
472 '')
473 ;;
474 ?*)
475 curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
476 if test "$curr_head" != "$orig_head"
477 then
478 git-update-ref \
479 -m "$GIT_REFLOG_ACTION: Undoing incorrectly fetched HEAD." \
480 HEAD "$orig_head"
481 die "Cannot fetch into the current branch."
482 fi
483 ;;
484 esac